//
//  ViewController.m
//  瀑布流
//
//  Created by FDC-Fabric on 2018/12/13.
//  Copyright © 2018年 FDC-Fabric. All rights reserved.
//

#import "ViewController.h"
#import "IconModel.h"
#import "UICollectionWaterLayout.h"
@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource>
@property(nonatomic,strong)UICollectionView *collectionView;
@property(nonatomic,strong)NSMutableArray *dataA;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    //加载plist数据
    NSString *path = [[NSBundle mainBundle]pathForResource:@"data.plist" ofType:nil];
    NSArray *arrat = [NSArray arrayWithContentsOfFile:path];
    for (int i = 0; i<arrat.count; i++) {
        NSDictionary *dic = arrat[i];
        IconModel *iconModel = [IconModel IconWithDictionay:dic];
        [self.dataA addObject:iconModel];
    }
    [self addCollectionView];
    
    
}
- (NSMutableArray *)dataA{
    if(_dataA == nil){
        _dataA = [NSMutableArray array];
    }
    return _dataA;
}
-(void)addCollectionView{
    UICollectionWaterLayout *layout = [UICollectionWaterLayout layoutWithColoumn:3 data:self.dataA verticleMin:10 horizonMin:10 leftMargin:10 rightMargin:10];

    self.collectionView = [[UICollectionView alloc]initWithFrame:[UIScreen mainScreen].bounds collectionViewLayout:layout];
    self.collectionView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.collectionView];
    self.collectionView.delegate = self;
    self.collectionView.dataSource = self;
    [self.collectionView registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:@"waterCell"];
    
}
-(NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return self.dataA.count;
    
}
- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath;
{
    
    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"waterCell" forIndexPath:indexPath];
    cell.backgroundColor = [UIColor colorWithRed:arc4random_uniform(256)/255.0 green:arc4random_uniform(256)/255.0 blue:arc4random_uniform(256)/255.0 alpha:1];
    return cell;
}
@end
